package vc.thinker.mqtt.forwardthinker;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import vc.thinker.absctacts.mqtt.protocol.AbstractNotSubscriptionMqttProtocol;
import vc.thinker.mqtt.config.ThinkerProdMqttConnectionProperties;
import vc.thinker.mqtt.forwardthinker.enums.FoxGatewayTopicDefinition;

/**
 * 富士康数据转发新科云 客户端
 *
 * @author HeTongHao
 * @since 2022-06-28 16:00
 */
@Slf4j
@Component
@ConditionalOnBean(ThinkerProdMqttConnectionProperties.class)
public class ThinkerProdProtocolClient extends AbstractNotSubscriptionMqttProtocol {
    public ThinkerProdProtocolClient(ThinkerProdMqttConnectionProperties mqttConnectionProperties) {
        super(mqttConnectionProperties);
    }

    @Scheduled(cron = "0 0/1 * * * ?")
    public void timeReport() {
        String json = "[{\"deviceCode\":\"ZGZC_NXTX_001\",\"events\":{\"ddeedww\":1,\"21312312\":1,\"686787887\":1,\"78078078088\":1,\"532637828739\":1},\"timestamp\":" + System.currentTimeMillis() + "}]";
        super.getMqttCommandPush().sendMqttMessage(FoxGatewayTopicDefinition.report.genTopic("CRRC_SMART_COCKPIT_SYSTEM"), json.getBytes());
    }
}
